TopologyRefiner Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends
Classes | Public Member Functions | Protected Member Functions | Friends | List of all members
TopologyRefiner Class Reference

Stores topology data for a specified set of refinement options. More...

`#include <topologyRefiner.h>`

## Classes
struct | AdaptiveOptions
| Adaptive refinement options. More...
struct | UniformOptions
| Uniform refinement options. More...

## Public Member Functions
| TopologyRefiner (Sdc::SchemeType type, Sdc::Options options=Sdc::Options())
| Constructor. More...
| ~TopologyRefiner ()
| Destructor. More...
Sdc::SchemeType | GetSchemeType () const
| Returns the subdivision scheme. More...
Sdc::Options | GetSchemeOptions () const
| Returns the subdivision options. More...
bool | IsUniform () const
| Returns true if uniform subdivision has been applied. More...
int | GetNumLevels () const
| Returns the number of refinement levels. More...
int | GetMaxLevel () const
| Returns the highest level of refinement. More...
int | GetMaxValence () const
| Returns the maximum vertex valence in all levels. More...
bool | HasHoles () const
| \ brief Returns true if faces have been tagged as holes More...
int | GetNumVerticesTotal () const
| Returns the total number of vertices in all levels. More...
int | GetNumEdgesTotal () const
| Returns the total number of edges in all levels. More...
int | GetNumFacesTotal () const
| Returns the total number of edges in all levels. More...
int | GetNumFaceVerticesTotal () const
| Returns the total number of face vertices in all levels. More...
TopologyLevel const & | GetLevel (int level) const
| Returns a handle to access data specific to a particular level. More...
High-level refinement and related methods
void | RefineUniform (UniformOptions options)
| Refine the topology uniformly. More...
UniformOptions | GetUniformOptions () const
| Returns the options specified on refinement. More...
void | RefineAdaptive (AdaptiveOptions options)
| Feature Adaptive topology refinement (restricted to scheme Catmark) More...
AdaptiveOptions | GetAdaptiveOptions () const
| Returns the options specified on refinement. More...
void | Unrefine ()
| Unrefine the topology (keep control cage) More...
Number and properties of face-varying channels:
int | GetNumFVarChannels () const
| Returns the number of face-varying channels in the tables. More...
Sdc::Options::FVarLinearInterpolation | GetFVarLinearInterpolation (int channel=0) const
| Returns the face-varying interpolation rule-set for a given channel. More...
int | GetNumFVarValuesTotal (int channel=0) const
| Returns the total number of face-varying values in all levels. More...

## Protected Member Functions
Vtr::internal::Level & | getLevel (int l)
Vtr::internal::Level const & | getLevel (int l) const
Vtr::internal::Refinement & | getRefinement (int l)
Vtr::internal::Refinement const & | getRefinement (int l) const

## Friends
template<class MESH >
class | TopologyRefinerFactory
class | TopologyRefinerFactoryBase
class | PatchTableFactory
class | EndCapGregoryBasisPatchFactory
class | EndCapLegacyGregoryPatchFactory
class | PtexIndices
class | PrimvarRefiner

## Detailed Description

Stores topology data for a specified set of refinement options.

Definition at line 49 of file topologyRefiner.h.

## Constructor & Destructor Documentation

TopologyRefiner | ( | Sdc::SchemeType | type,
|  | Sdc::Options | options = `Sdc::Options()`
| ) |  |

Constructor.

~TopologyRefiner | ( |  | ) |

Destructor.

## Member Function Documentation

AdaptiveOptions GetAdaptiveOptions | ( |  | ) | const
| inline

Returns the options specified on refinement.

Definition at line 155 of file topologyRefiner.h.

Sdc::Options::FVarLinearInterpolation GetFVarLinearInterpolation | ( | int | channel = `0` | ) | const
| inline

Returns the face-varying interpolation rule-set for a given channel.

Definition at line 245 of file topologyRefiner.h.

TopologyLevel const& GetLevel | ( | int | level | ) | const
| inline

Returns a handle to access data specific to a particular level.

Definition at line 93 of file topologyRefiner.h.

Vtr::internal::Level& getLevel | ( | int | l | ) |
| inlineprotected

Definition at line 190 of file topologyRefiner.h.

Vtr::internal::Level const& getLevel | ( | int | l | ) | const
| inlineprotected

Definition at line 191 of file topologyRefiner.h.

int GetMaxLevel | ( |  | ) | const
| inline

Returns the highest level of refinement.

Definition at line 72 of file topologyRefiner.h.

int GetMaxValence | ( |  | ) | const
| inline

Returns the maximum vertex valence in all levels.

Definition at line 75 of file topologyRefiner.h.

int GetNumEdgesTotal | ( |  | ) | const
| inline

Returns the total number of edges in all levels.

Definition at line 84 of file topologyRefiner.h.

int GetNumFacesTotal | ( |  | ) | const
| inline

Returns the total number of edges in all levels.

Definition at line 87 of file topologyRefiner.h.

int GetNumFaceVerticesTotal | ( |  | ) | const
| inline

Returns the total number of face vertices in all levels.

Definition at line 90 of file topologyRefiner.h.

int GetNumFVarChannels | ( |  | ) | const
| inline

Returns the number of face-varying channels in the tables.

Definition at line 240 of file topologyRefiner.h.

int GetNumFVarValuesTotal | ( | int | channel = `0` | ) | const

Returns the total number of face-varying values in all levels.

int GetNumLevels | ( |  | ) | const
| inline

Returns the number of refinement levels.

Definition at line 69 of file topologyRefiner.h.

int GetNumVerticesTotal | ( |  | ) | const
| inline

Returns the total number of vertices in all levels.

Definition at line 81 of file topologyRefiner.h.

Vtr::internal::Refinement& getRefinement | ( | int | l | ) |
| inlineprotected

Definition at line 193 of file topologyRefiner.h.

Vtr::internal::Refinement const& getRefinement | ( | int | l | ) | const
| inlineprotected

Definition at line 194 of file topologyRefiner.h.

Sdc::Options GetSchemeOptions | ( |  | ) | const
| inline

Returns the subdivision options.

Definition at line 63 of file topologyRefiner.h.

Sdc::SchemeType GetSchemeType | ( |  | ) | const
| inline

Returns the subdivision scheme.

Definition at line 60 of file topologyRefiner.h.

UniformOptions GetUniformOptions | ( |  | ) | const
| inline

Returns the options specified on refinement.

Definition at line 126 of file topologyRefiner.h.

bool HasHoles | ( |  | ) | const
| inline

\ brief Returns true if faces have been tagged as holes

Definition at line 78 of file topologyRefiner.h.

bool IsUniform | ( |  | ) | const
| inline

Returns true if uniform subdivision has been applied.

Definition at line 66 of file topologyRefiner.h.

void RefineAdaptive | ( | AdaptiveOptions | options | ) |

Feature Adaptive topology refinement (restricted to scheme Catmark)

Parameters

  options | Options controlling adaptive refinement

void RefineUniform | ( | UniformOptions | options | ) |

Refine the topology uniformly.

Parameters

  options | Options controlling uniform refinement

void Unrefine | ( |  | ) |

Unrefine the topology (keep control cage)

## Friends And Related Function Documentation

friend class EndCapGregoryBasisPatchFactory
| friend

Definition at line 185 of file topologyRefiner.h.

friend class EndCapLegacyGregoryPatchFactory
| friend

Definition at line 186 of file topologyRefiner.h.

friend class PatchTableFactory
| friend

Definition at line 184 of file topologyRefiner.h.

friend class PrimvarRefiner
| friend

Definition at line 188 of file topologyRefiner.h.

friend class PtexIndices
| friend

Definition at line 187 of file topologyRefiner.h.

friend class TopologyRefinerFactory
| friend

Definition at line 182 of file topologyRefiner.h.

friend class TopologyRefinerFactoryBase
| friend

Definition at line 183 of file topologyRefiner.h.

The documentation for this class was generated from the following file:

- opensubdiv/far/topologyRefiner.h